# tourmaline

Tourmaline is a (planned) agnostic, asynchronous and awesome installer framework


## Usage

Just run `cargo run -- help` or `trm help` for now.


## Scripts

Scripts for all supported distros are stored in the `config` folder of this repository.
Each distro has its own folder with several subfolders corresponding to all integration tasks.

```
<distro>
  | <task>
      | up.nu
      | down.nu 
  | <task>
      | up.nu
      | down.nu
```

The `up.nu` scripts contain the required steps to apply the change described by the task.
This can include installing packages, creating configuration files and starting systemd units.

The `down.nu` scripts contain the steps to revert the change applied by a task. These scripts will
later be used to offer functionalities like reinstalling grub or changing installed kernels.
 

# License

> GPL v3

See LICENSE.
